<?php
require 'dbconnect.php';
class Paypal_IPN
{
    /** @var string $_url The paypal url to go to through cURL
    private $_url;

    /**
    * @param string $mode 'live' or 'sandbox' 
    */
    public function __construct($mode = 'live')
    {
        if ($mode == 'live')
        $this->_url = 'https://www.paypal.com/cgi-bin/webscr';

        else
        $this->_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
    }

    public function run()
    {
        $postFields = 'cmd=_notify-validate';

        foreach($_POST as $key => $value)
        {
            $postFields .= "&$key=".urlencode($value);
            $email = $_POST['payer_email'];
            $amount = $_POST['mc_gross'];
            $memo = $_POST['memo'];
        }

        $ch = curl_init();

        curl_setopt_array($ch, array(
            CURLOPT_URL => $this->_url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $postFields
        ));

        $result = curl_exec($ch);
        curl_close($ch);

        $fh = fopen('result.txt', 'w');
        fwrite($fh, $result . ' -- ' . $postFields);
        
	
	if (strcmp ($result, "VERIFIED") == 0) 
	{
	
	    $to      = $email;  
	    $subject = 'Payment Confirmation';  
	    $message = ' 
 			'.$email.' --- ' .$amount.' 			
	    Thank you for your purchase!! ';
	    $headers = 'From:noreply@yourdomain.com' . "\r\n";  
  	    mail($to, $subject, $message, $headers); 
  	   
	    $q = "INSERT INTO payment_test (email,amount,NoteFromBuyer) VALUES('$email','$amount','$memo')"; 
	    $query = mysql_query($q);
	   if( $query )
	   {
	     fwrite($fh, 'OK');
	   } else
	   {
    		 fwrite($fh,'Invalid query: ' . mysql_error() );
	   }
	}
	fclose($fh);
    }
}





?>




