<?php
require 'Paypal_IPN.php';
$paypal= new Paypal_IPN('sandbox');
$paypal->run();
/*
require("dbconnect.php"); // this holds our database connection credentials
// Paypal Posts HTML Form variables to this page - we will post them back with an extra parameter cmd with value _notify-validate
//DEBUGGING - set this to true to write debug files
$debug = true;

// set up variables for our own local settings
$account_owner = "angotra@yahoo.co.in"; //Initialise Paypal account holder
$headers = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";
$mail_To = "priyanka.angotra@gmail.com"; //Enter the email for alerts and confirmations

//Build the data to post back to Paypal
$postback = 'cmd=_notify-validate'; 
// go through each of the posted vars and add them to the postback variable
foreach ($_POST as $key => $value) {
$value = urlencode(stripslashes($value));
$postback .= "&$key=$value";
}

//DEBUGGING - export a text file with all the post data on it
if ($debug)
{
$ourFileName = "debug/debug1_postdata.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fwrite($ourFileHandle, $postback);
fclose($ourFileHandle);
}

// build the header string to post back to PayPal system to validate
$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($postback) . "\r\n\r\n";

// Send to paypal or the sandbox depending on whether you're live or developing
// comment out one of the following lines
//$fp = fsockopen ('www.sandbox.paypal.com', 80, $errno, $errstr, 30);//open the connection
$fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30);
// or use port 443 for an SSL connection
//$fp = fsockopen ('ssl://www.paypal.com', 443, $errno, $errstr, 30);


if (!$fp) 
{
// HTTP ERROR Failed to connect
//error handling or email here

 }

else // if we've connected OK
{
 //DEBUGGING - export a text file to show we've connected OK
if ($debug)
{
$ourFileName = "debug/debug2_connected.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fclose($ourFileHandle);
}

fputs ($fp, $header . $postback);//post the data back
while (!feof($fp)) 
{
$response = fgets ($fp, 1024);

 //DEBUGGING - export a text file containing the response
if ($debug)
{
$ourFileName = "debug/debug3_fgets.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fwrite($ourFileHandle, $response);
fclose($ourFileHandle);
}

if (strcmp ($response, "VERIFIED") == 0) 
{//It's verified

//DEBUGGING - export a text file to confirm verification
if ($debug)
{
$ourFileName = "debug/debug4_verified.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fclose($ourFileHandle);
}

// assign posted variables to local variables, apply urldecode to them all at this point as well, makes things simpler later
 $txn_type = $_POST['txn_type'];//read the type of payment
$purchase_type = $_POST['custom'];//this is a custom variable as we're using this for two different sorts of payments

$i=1;
while (isset($_POST['item_number'.$i]))//read the item details
{
$item_ID[$i]=$_POST['item_number'.$i];
$item_name[$i]=urldecode($_POST['item_name'.$i]);
$item_cost[$i]=$_POST['mc_gross_'.$i];
$i++;
}
$item_count = $i-1;
$workshop_name = urldecode($_POST['item_name']);//only one item means no cart so workshop
$workshopid = urldecode($_POST['item_number']);//ditto, for id
$quantity = $_POST['quantity'];

$payment_status = $_POST['payment_status'];//read the payment details and the account holder
$payment_currency = $_POST['mc_currency'];
$payment_total = $_POST['mc_gross']; 
$posted_account_owner = urldecode($_POST['receiver_email']);
$buyer_email = urldecode($_POST['payer_email']);//read the buyer details
$first_name = urldecode($_POST['first_name']);
$last_name = urldecode($_POST['last_name']);
$address_street = urldecode($_POST['address_street']);
$address_posttown = urldecode($_POST['address_city']);
$address_county = urldecode($_POST['address_state']);
$address_postcode = urldecode($_POST['address_zip']);

//DEBUGGING - export a text file to check the confirmation
if ($debug)
{
$ourFileName = "debug/debug5_confirmedok.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fclose($ourFileHandle);
}
 // further checks
 if(($payment_status == 'Completed') && //payment_status = Completed
($posted_account_owner == $account_owner) && //comes from the right account
($purchase_type == "shop" || $purchase_type == "workshop") && //is of the type that we expect 
($payment_currency == "GBP")) // and in the right currency 
 {

// if we've reached this point all is well, now we can send emails and update databases with confidence
//DEBUGGING - export a text file to check the payment status
if ($debug)
{
$ourFileName = "debug/debug6_statuscompleted.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fclose($ourFileHandle);
} 

//Build an email to the shop owner

if ($purchase_type == "shop")//here's the stuff for a shop purchase
{
$mail_Subject = "A purchase has been completed from your shop";

$mail_message = "<html><head></head><body style=\"font-family:Arial,Helvetica,sans-serif;font-size:12pt\"><p>Buyer:<br/>";
$mail_message .= $first_name." ".$last_name."<br/>";
$mail_message .= $address_street."<br/>";
$mail_message .= $address_posttown."<br/>";
$mail_message .= $address_county."<br/>";
$mail_message .= $address_postcode."<br/></p><p>";

for ($j=1;$j<=$item_count;$j++)
{
$mail_message .= "Item: ".$item_ID[$j]." ".$item_name[$j]." &pound;".$item_cost[$j]."<br/>";
}

$mail_message .= "</p></body></html>";

mail($mail_To, $mail_Subject, $mail_message, $headers);

//Build an email to the buyer

$mail_Subject2 = "Thank you for your purchase";

$mail_message2 = "<html><head></head><body style=\"font-family:Arial,Helvetica,sans-serif;font-size:12pt\"><p>Dear ".$first_name."</p>";
$mail_message2 .= "<p>Thank you for your order - the details are confirmed below. I'll let you know when I've popped it in the post.</p><p>";

for ($j=1;$j<=$item_count;$j++)
{
$mail_message2 .= $item_name[$j]." &pound;".$item_cost[$j]."<br/>";
}

$mail_message2 .= "</p><p>Total: &pound;".$payment_total."</p>";
$mail_message2 .= "<p>Regards<br/>Your Name </p></body></html>";

mail($buyer_email, $mail_Subject2, $mail_message2, $headers);

//Update the database
for ($j=1;$j<=$item_count;$j++)
{
$qstring="UPDATE items SET Sold = 'Sold' WHERE ID = '".$item_ID[$j]."'";
mysql_query($qstring);
}
}//end shop

if ($purchase_type == "workshop")//here's the stuff for a workshop booking
{
//Build an email to the workshop owner
$mail_Subject = "Workshop booking";

$mail_message = "<html><head></head><body style=\"font-family:Arial,Helvetica,sans-serif;font-size:12pt\"><p>Workshop booked by:</p>";
$mail_message .= "<p>".$first_name." ".$last_name."<br/>";
$mail_message .= $address_street."<br/>";
$mail_message .= $address_posttown."<br/>";
$mail_message .= $address_county."<br/>";
$mail_message .= $address_postcode."<br/></p>";

$mail_message .= "<p>Workshop: ".$workshop_name." Payment: &pound;".$payment_total."</p>";

$mail_message .= "<p>Number of places: ".$quantity."</p>";
$mail_message .= "</body></html>";

mail($mail_To, $mail_Subject, $mail_message, $headers);

//Build an email to the punter
$mail_Subject2 = "Thank you for your workshop booking";

$mail_message2 = "<html><head></head><body style=\"font-family:Arial,Helvetica,sans-serif;font-size:12pt\"><p>Dear ".$first_name."</p>";
$mail_message2 .= "<p>Thank you for your booking - the details are confirmed below. </p>";
$mail_message2 .= "<p>Workshop: ".$workshop_name."</p>";
$mail_message2 .= "<p>Payment: &pound;".$payment_total."</p>";
$mail_message2 .= "<p>Number of places: ".$quantity."</p>";

$mail_message2 .= "<p>I'll send out a reminder of venue etc. nearer the date. I look forward to seeing you at the workshop.</p>";
 $mail_message2 .= "<p>Regards<br/>Your name </p></body></html>";

mail($buyer_email, $mail_Subject2, $mail_message2, $headers);

 //Update the database
$qstring="UPDATE workshops SET Places = (Places-".$quantity."), Attendees = concat(Attendees,';".$buyer_email."') WHERE ID = '".$workshopid."'";
mysql_query($qstring);

//DEBUGGING - export a text file to check the update string
if ($debug)
{
$ourFileName = "debug/debug7_workshopupdate.txt";
$ourFileHandle = fopen($ourFileName, 'w') or die("can't open file");
fwrite($ourFileHandle, $qstring);
fclose($ourFileHandle);
}

}

mysql_close($con);
 
}
else //the Paypal response is VERIFIED but something else has failed - maybe it's a refund, or a different payment type
{
// optionally send an email
//error handling or email here  

 }
}
else if (strcmp ($response, "INVALID") == 0) 
{ 
//the Paypal response is INVALID, not VERIFIED
// This implies something is wrong 
// If this happens, enable debugging and start by look at the contents of debug1_postdata.txt

$to      = 'priyanka.angotra@gmail.com';  
			$subject = 'Download Area | Invalid Payment';  
			$message = ' 
 
			Dear Administrator, 
 
			A payment has been made but is flagged as INVALID. 
			Please verify the payment manualy and contact the buyer. 
  
			';  
			$headers = 'From:noreply@yourdomain.com' . "\r\n";  
  
			mail($to, $subject, $message, $headers);  
  

if ($txn_type != "")
{
//error handling or email here
}
}
} //end of while
fclose ($fp);
}*/
?>